<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use Teknisa\Libs\Util\Environment;
use SupNext\Util\Util;
use SupNext\Services\QuoteSheetGrid\DeleteProductService as Service;
use SupNext\Controllers\QuoteSheetGrid\DeleteRegionController as DeleteRegion;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class DeleteProductController {
  private $environment;
  private $util;
  private $service;
  private $deleteRegion;

  public function __construct(
    Environment $environment,
    Util $util,
    Service $service,
    DeleteRegion $deleteRegion
  ) {
    $this->environment  = $environment;
    $this->util         = $util;
    $this->service      = $service;
    $this->deleteRegion = $deleteRegion;
  }

 public function deleteProduct(Request $request, Response $response) {
    try{
      $data = $request->getParameters();

      foreach ($data as $product) {
        $product = json_decode($product, true);
        $product["NRORG"] = $this->environment->getNrorg();
        $this->service->deleteProduct($product);

        $prodInfo = $this->deleteRegion->getInfoToDelete($product);

        foreach ($prodInfo as $prod) {
          $this->deleteRegion->service->procItemcoleAtuCustosup($prod);
        }
      }

    } catch (\Exception $exception) {
      throw new \Exception("Erro ao deletar produto: " . $exception->getMessage(), 500);
    }
  }

  private function processDataDeleteProd(array $product): array {
    $conditionsArray = [
      "CDFILIAL"    => $product["CDFILIAL"],
      "NRCOLEPRECO" => $product["NRCOLEPRECO"],
      "CDPRODUTO"   => $product["CDPRODUTO"] ?? "T",
      "CDPRODUTO"   => $product["CDPRODUTO"] ?? "T",
      "CDREGIAO"    => $product["CDREGIAO"] ?? "T",
      "CDREGIAO"    => $product["CDREGIAO"] ?? "T",
      "CDFORNECED"  => $product["CDFORNECED"] ?? "T",
      "CDFORNECED"  => $product["CDFORNECED"] ?? "T",
      "CDMARCA"     => $product["CDMARCA"] ?? "T",
      "CDMARCA"     => $product["CDMARCA"] ?? "T",
      "NRORG"       => $product["NRORG"]
    ];

    $prodInfo = $this->util->filteredDataSet($conditionsArray, "getProdInfoToDelete");

    return $prodInfo;
  }
}