<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use Teknisa\Libs\Util\Environment;
use SupNext\Util\Util;
use SupNext\Services\QuoteSheetGrid\DeleteSupplierService as Service;
use SupNext\Controllers\QuoteSheetGrid\DeleteRegionController as DeleteRegion;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class DeleteSupplierController {
  private $environment;
  private $util;
  private $service;
  private $deleteRegion;

  public function __construct(
    Environment $environment,
    Util $util,
    Service $service,
    DeleteRegion $deleteRegion
  ) {
    $this->environment  = $environment;
    $this->util         = $util;
    $this->service      = $service;
    $this->deleteRegion = $deleteRegion;
  }

 public function deleteSupplier(Request $request, Response $response): void {
    try{
      $data = $request->getParameters();

      foreach ($data as $supplier) {
        $supplier = json_decode($supplier, true);
        $supplier["NRORG"] = $this->environment->getNrorg();
        $this->service->deleteSupplier($supplier);

        $prodInfo = $this->deleteRegion->getInfoToDelete($supplier);

        foreach ($prodInfo as $prod) {
          $this->deleteRegion->service->procItemcoleAtuCustosup($prod);
        }
      }

    } catch (\Exception $exception) {
      throw new \Exception("Erro ao deletar fornecedor: " . $exception->getMessage(), 500);
    }
  }
}