<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Services\QuoteSheetGrid\DuplicateQuotationService as Service;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class DuplicateQuotationController
{
    private $service;

    public function __construct(Service $service)
    {
        $this->service = $service;
    }

    public function duplicateQuotation(Request $request, Response $response)
    {
        $data = $request->getParameters();

        try {
            $logCount = $this->service->procDuplicateQuotation($data);

            return $response->addDataSet(
                new DataSet("updatePaymentMethod", [
                    "message" =>
                        "Duplicação da cotação realizada com sucesso.",
                    $logCount,
                    "status_code" => 200,
                ])
            );
        } catch (\Exception $exception) {
            throw new \Exception(
                "Erro ao duplicar cotação: " . $exception->getMessage(),
                500
            );
        }
    }
}
