<?php

namespace SupNext\Controllers\QuoteSheetGrid;

use SupNext\Controllers\QuoteSheetGrid\ReplicateQuotationController as ReplicateQuotation;
use SupNext\Services\QuoteSheetGrid\DuplicateQuotationInconsistenciesService as Service;
use SupNext\Util\Util;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class DuplicateQuotationInconsistenciesController
{
  private $replicateQuotation;
  private $service;
  private $util;

  public function __construct(ReplicateQuotation $replicateQuotation, Service $service, Util $util)
  {
    $this->replicateQuotation = $replicateQuotation;
    $this->service = $service;
    $this->util    = $util;
  }

  public function getInconsistencies(Request $request, Response $response)
  {
    $data = $request->getParameters();

    try {
      $data["REAJUSTE"] = (float) $data["REAJUSTE"];
      $data["NRSEMAINIC"] = (string) $data["NRSEMAINIC"];
      $data["NRSEMAFINAL"] = (string) $data["NRSEMAFINAL"];
      $data = $this->util->implodeFields($data, ["CDREGIAO", "CDREGIAOOL"]);

      if (isset($data["DUPLICAOL"]) && $data["DUPLICAOL"] === "S") $this->replicateQuotation->checkOLRegion($data);

      $inconsistencies = $this->service->procInsertTempDuplicaQuotation($data);

      foreach($inconsistencies as &$inconsistencie)
        $inconsistencie = (int) $inconsistencie;

      return $response->addDataSet(new DataSet("getInconsistencies", [$inconsistencies, "status_code" => 200]));
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao pegar inconsistências dos itens da cotação: " . $exception->getMessage(), 500);
    }
  }
}
