<?php

namespace SupNext\Services\QuoteSheetGrid;

use Doctrine\DBAL\Connection;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class DuplicateQuotationInconsistenciesService
{
  private $connection;

  public function __construct(Connection $connection)
  {
    $this->connection = $connection;
  }

  public function procInsertTempDuplicaQuotation(array $data)
  {
    try {
      $procedure = new StoredProcedure($this->connection, 'INSERT_TMPDUPLICACOTACAO');

      $procedure->addParam(new Param("P_CDFILIALORIG",    Param::PARAM_INPUT,  $data["CDFILIAL"],      Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_NRCOLEORIG",      Param::PARAM_INPUT,  $data["NRCOLEPRECO"],   Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_CDOPERADORIG",    Param::PARAM_INPUT,  $data["CDOPERADOR"],    Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_CDREGIAORIG",     Param::PARAM_INPUT,  $data["CDREGIAO"],      Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_DTINIVALORI",     Param::PARAM_INPUT,  $data["DTINIVALCOL"],   Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_DTFINVALORI",     Param::PARAM_INPUT,  $data["DTFINVALCOL"],   Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_DTINIVALNEW",     Param::PARAM_INPUT,  $data["DTNOVINIVAL"],   Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_DTFINVALNEW",     Param::PARAM_INPUT,  $data["DTNOVFINVAL"],   Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_DTCOLEPREC",      Param::PARAM_INPUT,  $data["DTCOLEPREC"],    Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_VRREAJUSTE",      Param::PARAM_INPUT,  $data["REAJUSTE"],      Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_CDOPERINCL",      Param::PARAM_INPUT,  $data["CDOPERINCL"],    Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_DUPITSEMPRECO",   Param::PARAM_INPUT,  $data["DUPITSEMPRECO"], Param::PARAM_TYPE_STR));
      $procedure->addParam(new Param("P_TOTAL",           Param::PARAM_OUTPUT, NULL,                   Param::PARAM_TYPE_INT, 20000));
      $procedure->addParam(new Param("P_TOTALERROR",      Param::PARAM_OUTPUT, NULL,                   Param::PARAM_TYPE_INT, 20000));
      $procedure->addParam(new Param("P_NRDUPLICA",       Param::PARAM_OUTPUT, NULL,                   Param::PARAM_TYPE_INT, 20000));

      return $procedure->execute();
    } catch (\Exception $exception) {
      throw new \Exception("Erro ao executar procedure duplica/reduplica cotação: " . $exception->getMessage(), 500);
    }
  }
}
