<?php

namespace SupNext\Services\QuoteSheetGrid;

use Doctrine\DBAL\Connection;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class DuplicateQuotationService
{
    private $connection;

    public function __construct(Connection $connection)
    {
        $this->connection = $connection;
    }

    public function procDuplicateQuotation(array $data)
        {
        try
        {
            $procedure = new StoredProcedure($this->connection, 'DUPLICA_ITEMCOLE');

            $procedure->addParam(new Param("P_NRDUPLICA",   Param::PARAM_INPUT,  $data["NRDUPLICA"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDOPERINCL",  Param::PARAM_INPUT,  $data["CDOPERINCL"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_LOGCOUNT",    Param::PARAM_OUTPUT, NULL,                 Param::PARAM_TYPE_STR));

            return $procedure->execute();
        }
        catch (\Exception $exception)
        {
            throw new \Exception("Erro ao executar procedure duplica cotação: " . $exception->getMessage(), 500);
        }
    }
}
