<?php

namespace SupNext\Services\QuoteSheetGrid;

use Doctrine\DBAL\Connection;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class ReplicateQuotationService {
    private $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function procReplicateQuotation(array $data) {
        try {
            $data['CDFORNECED'] = isset($data['CDFORNECED']) ? ($data['CDFORNECED']) : NULL;

            $procedure = new StoredProcedure($this->connection, 'SUP_COTACAO.DUPLICA_COTACAO');

            $procedure->addParam(new Param("P_CDFILIAL",    Param::PARAM_INPUT,  $data["CDFILIAL"],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDFILIPROC",  Param::PARAM_INPUT,  $data["CDFILIPROC"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_NRCOLEPRECO", Param::PARAM_INPUT,  $data["NRCOLEPRECO"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_NRSEMAINIC",  Param::PARAM_INPUT,  $data["NRSEMAINIC"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_NRSEMAFINAL", Param::PARAM_INPUT,  $data["NRSEMAFINAL"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DTNOVINIVAL", Param::PARAM_INPUT,  $data["DTNOVINIVAL"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DTNOVFINVAL", Param::PARAM_INPUT,  $data["DTNOVFINVAL"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DTINIVALCOL", Param::PARAM_INPUT,  $data["DTINIVALCOL"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DTFINVALCOL", Param::PARAM_INPUT,  $data["DTFINVALCOL"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DTCOLEPREC",  Param::PARAM_INPUT,  $data["DTCOLEPREC"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_REAJUSTE",    Param::PARAM_INPUT,  $data["REAJUSTE"],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_NRCOLEDUP",   Param::PARAM_INPUT,  $data["NRCOLEPRECO"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_IDDUPLICA",   Param::PARAM_INPUT,  $data["IDDUPLICA"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDOPERADOR",  Param::PARAM_INPUT,  $data["CDOPERADOR"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_TCDOPERADOR", Param::PARAM_INPUT,  $data["TCDOPERADOR"], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDOPERINCL",  Param::PARAM_INPUT,  $data["CDOPERINCL"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDREGIAO",    Param::PARAM_INPUT,  $data["CDREGIAO"],    Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_DUPLICAOL",   Param::PARAM_INPUT,  $data["DUPLICAOL"],   Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDFORNOL",    Param::PARAM_INPUT,  $data["CDFORNECED"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_CDREGIAOL",   Param::PARAM_INPUT,  $data["CDREGIAOOL"],  Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param("P_COTA_N_DUP",  Param::PARAM_OUTPUT, NULL,                 Param::PARAM_TYPE_STR, 20000));

            return $procedure->execute();
        } catch (\Exception $exception) {
            throw new \Exception("Erro ao executar procedure reduplica cotação: " . $exception->getMessage(), 500);
        }
    }
}