import { TekGrid } from '@zeedhi/teknisa-components-common';
import { ModalService } from '@zeedhi/common';
import { Metadata } from '@zeedhi/core';
import { AppState } from '@/controllers/AppState';

export class InconsistenciesController {
  private appState: AppState;

  constructor() {
    this.appState = AppState.getInstance();
  }

  public async createModal(): Promise<void> {
    await ModalService.createFromJson(
      '/modals/quoteSheetGrid/inconsistenciesModal',
      true,
    );
  }

  public destroyModal(): void {
    ModalService.getModal('inconsistenciesModal')?.destroy();
  }

  public openModal(data): void {
    ModalService.getModal('inconsistenciesModal').show();

    setTimeout(() => {
      const grid = Metadata.getInstance<TekGrid>('inconsistenciesGrid');

      grid.datasource.setFilter({
        P_NRDUPLICA: data.P_NRDUPLICA,
        P_NRORG: this.appState.NRORG,
        P_CDFILIAL: this.appState.CDFILIAL,
      });
    }, 200);
  }

  public closeModal(): void {
    ModalService.getModal('inconsistenciesModal').hide();
  }
}
