import Vue from 'vue';
import { Messages, Metadata } from '@zeedhi/core';
import App from './App.vue';
import { vuetify } from './plugins';
import './registerServiceWorker';
import 'roboto-fontface/css/roboto/roboto-fontface.css';
import './styles/style.scss';

Vue.config.productionTip = false;
const loadMessages = async () => {
  const messages = await Metadata.get('assets/json/messages', true);
  const wordsEnUs = await Metadata.get('assets/json/words/en_us', true);
  const wordsEsCl = await Metadata.get('assets/json/words/es_cl', true);
  const wordsEsCo = await Metadata.get('assets/json/words/es_co', true);
  const wordsEsEs = await Metadata.get('assets/json/words/es_es', true);
  const wordsEsMx = await Metadata.get('assets/json/words/es_mx', true);
  const wordsPtBr = await Metadata.get('assets/json/words/pt_br', true);

  Messages.add({
    'en-US': {
      translation: {
        ...wordsEnUs,
      },
    },
    'es-CL': {
      translation: {
        ...wordsEsCl,
      },
    },
    'en-CO': {
      translation: {
        ...wordsEsCo,
      },
    },
    'en-ES': {
      translation: {
        ...wordsEsEs,
      },
    },
    'en-MX': {
      translation: {
        ...wordsEsMx,
      },
    },
    'pt-BR': {
      translation: {
        ...messages,
        ...wordsPtBr,
      },
    },
  });
};

loadMessages().then(() => {
  new Vue({
    vuetify,
    render: (h) => h(App),
  }).$mount('#app');
});
